# Calc-Ultra

[![MIT License](https://img.shields.io/badge/License-MIT-green.svg)](https://opensource.org/license/mit/) [![Version](https://img.shields.io/badge/Version-1.3.8-blue.svg)](https://pypi.org/project/calc-ultra/)

> **Advanced math made easy**

(Turn on dark mode for a better aesthetic) 📲

Calc-Ultra (styled as CALC ULTRA) is a multi-functional calculator that uses a command-line/menu-based interface. Little Python background knowledge is needed to use this calculator! (Please star the GitHub repo if you find this project helpful! ❤️)

Supports:

- Simple calculations (complex numbers supported!)
- Derivatives
- Partials
- Implicit differentiation
- Extrema Calculator
- Limits
- Antiderivatives
- Definite integrals
- Improper integrals
- Double integrals
- Solving (sets) of equation(s)
- Vector/matrix operations
- Taylor Polynomial Approximations
- **A perfect interface to do calculations!**  

## Chinese version

Want to check out the Chinese version? Visit the Chinese version [here](https://github.com/sudoer-Huatao/calc_ultra-chinese) (Work in progress)! 🇨🇳

## Installation and Running

> Run the calculus calculator with a single line of code

Use the following command to install Calc-Ultra:

`pip3 install calc-ultra`

or

`python3 -m pip install calc-ultra` if you have lower versions of pip.

Due to Python import identifiers restrictions, please import Calc-Ultra as "calc_ultra" and not "calc-ultra".

Import Calc-Ultra like so to use:

`from calc_ultra import main`

Please make sure you have the latest version installed. To update calc-ultra, run the following command:

`pip3 install --upgrade calc-ultra`

## Requirements

Calc-Ultra requires these modules/packages to be installed:

- `sympy`
- `numpy`
- `matplotlib`
- `scipy`
- `rich`
- `prompt-toolkit`

If you do not have them installed, no need to worry! These modules should be installed automatically if you don't have them.

## Acknowledgements

> Without them, this would be impossible

A big thank-you to all GitHub users who gave feedback and/or starred this repository. ⭐️ Your encouragement is our motivation.
The following contributors deserve a SPECIAL THANK-YOU 👍❤️:

- [@Haobot](https://github.com/Haobot) for troubleshooting and feedback!
- [@FanboFB](https://github.com/FanboFB) for feedback and ideas for improvement!

This program was made using `sympy` for calculation and `numpy`, `scipy`, and `matplotlib` for graphing.

## New Features Demo

Taylor Approximation demo: (VS Code)
![taylor](https://github.com/user-attachments/assets/680a33dc-2900-43af-99f0-f0f9803a10e0)


Extrema calculator demo: (VS Code)
![extrema](https://github.com/user-attachments/assets/7132c094-f705-4ab4-a1ae-57aa2cdd1d74)

For more info, check the changelog.

## License

This project is licensed under the terms of the MIT license.
